#include <kb.h>

/*
 MODER  00->input, 01->output, 10->AF, 11->analog
 OTYPER 0->PP, 1->OD
 PUPDR  00-> nopull, 01-> pullup, 10-> pulldn

*/

//  
//   enum_ 
// true       
bool btn_scan(void)
{
 static u8 count[BNUM][3];
 bool retval = false;

  //    
 for(int i=0;i<BNUM;i++)
 {
  int pos = i;

  //     
  volatile bool input = (GPIO_btns[i].GPIOx->IDR & (1<<GPIO_btns[i].shift));

  // 
  key_coll(input, count, (keyst*)btn, pos);

  if(btn[pos]!= rls) retval = true;
 }

 return retval;
}

void key_coll(const bool input, u8 count[][3], keyst btn[], const u8 pos)
{
 //  
 if (!input)
 {
  if(count[pos][0]>LP)
  {
   count[pos][0]=0;

   if(btn[pos]==rls) btn[pos]=prs;

   if(count[pos][1]>LH)
   {
    btn[pos]=hold;
    count[pos][1]=0;
   }
   else
    count[pos][1]++;
  }
  else
   count[pos][0]++;

  count[pos][2]=LR;
 }
 else //   ,       
 {
  if(count[pos][2])
   count[pos][2]--;
  else
  {
   count[pos][0]=0;
   count[pos][1]=0;

   btn[pos]=rls;
  }
 }
}

//________________________________________________


